#include <stdio.h>
#include <stdlib.h>

#include "liste.h"


//-----------------------------------------------
LISTE initListe()      
{
  LISTE liste1;

  liste1=(ELEMLISTE*)NULL;

  return(liste1);
}

//-----------------------------------------------
int tailleListe(LISTE liste)	
{
  ELEMLISTE* visitor; 
  int counter; 

  visitor = liste;
  counter = 0; 
  while(visitor != NULL)
    {
      visitor=visitor->suivant;
      counter++; 
    }

  return counter; 
}	

//-----------------------------------------------
void afficherListe(LISTE liste)	
{
  ELEMLISTE* visitor;
 
  visitor=liste;
  while(visitor != NULL)
    {
      fprintf(stdout,"|%d|",visitor->elem);
      visitor=visitor->suivant;
    }
  fprintf(stdout,"|--\n");
}	


//-----------------------------------------------
int ajouterListe (LISTE* pliste, int elem)	
{ 
  ELEMLISTE *newelem;  
  newelem = (ELEMLISTE *)malloc(sizeof(ELEMLISTE));

  if (newelem == 0)
    { 
      fprintf(stderr, "ajouterListe: plus de place memoire \n");
      return 1; 
    }
  else 
    {
      //on remplit newelem
      newelem->elem = elem;
      newelem->suivant = *pliste;
      //on met a jour la liste
      *pliste = newelem;

      return 0;
    }
}

//-----------------------------------------------
int retirerListe(LISTE *pliste)	
{
  ELEMLISTE *elem1;
  int val;

  if (*pliste == NULL)
    {
      fprintf(stderr, "retirerListe: liste vide \n");
      val = 0; 
    }
 else
   {
     elem1 = *pliste; //premier element
     val = elem1->elem; //sa valeur
     *pliste = elem1->suivant; //mise a jour du premier element
     free(elem1); //liberation de la memoire
   }
  return(val);
}

//-----------------------------------------------
void viderListe(LISTE *pliste)	
{
  while (*pliste != NULL)
    {
      retirerListe(pliste); 
    }
}


     



